Index: trunk/LMDZ.TITAN/libf/phytitan/physiq.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/physiq.F	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/physiq.F	(revision 1056)
@@ -13,6 +13,5 @@
 c
 c Modifications pour la physique de Titan
-c  adaptation a partir de celle de Venus
-c     S. Lebonnois (LMD/CNRS) Mai 2008
+c     S. Lebonnois (LMD/CNRS) Juin 2013: Parallelisation
 c
 c ---------------------------------------------------------------------
@@ -28,24 +27,24 @@
 c  Arguments:
 c
-c nlon------input-I-nombre de points horizontaux
-c nlev------input-I-nombre de couches verticales
-c nqmax-----input-I-nombre de traceurs
-c debut-----input-L-variable logique indiquant le premier passage
-c lafin-----input-L-variable logique indiquant le dernier passage
-c rjourvrai-input-R-NBjours
-c gmtime----input-R-temps universel dans la journee (fraction de jour)
-c pdtphys---input-R-pas d'integration pour la physique (seconde)
-c paprs-----input-R-pression pour chaque inter-couche (en Pa)
-c pplay-----input-R-pression pour le mileu de chaque couche (en Pa)
-c ppk  -----input-R-fonction d'Exner au milieu de couche
-c pphi------input-R-geopotentiel de chaque couche (g z) (reference sol)
-c pphis-----input-R-geopotentiel du sol
-c presnivs--input_R_pressions approximat. des milieux couches ( en PA)
-c u---------input-R-vitesse dans la direction X (de O a E) en m/s
-c v---------input-R-vitesse Y (de S a N) en m/s
-c t---------input-R-temperature (K)
-c qx--------input-R-mass mixing ratio traceurs (kg/kg) 
-c d_t_dyn---input-R-tendance dynamique pour "t" (K/s)
-c omega-----input-R-vitesse verticale en Pa/s
+c nlon----input-I-nombre de points horizontaux
+c nlev----input-I-nombre de couches verticales
+c nqmax---input-I-nombre de traceurs
+c debut---input-L-variable logique indiquant le premier passage
+c lafin---input-L-variable logique indiquant le dernier passage
+c rjour---input-R-numero du jour de l'experience
+c gmtime--input-R-temps universel dans la journee (0 a RDAY s)
+c pdtphys-input-R-pas d'integration pour la physique (seconde)
+c paprs---input-R-pression pour chaque inter-couche (en Pa)
+c pplay---input-R-pression pour le mileu de chaque couche (en Pa)
+c ppk  ---input-R-fonction d'Exner au milieu de couche
+c pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
+c pphis---input-R-geopotentiel du sol
+c presnivs-input_R_pressions approximat. des milieux couches ( en PA)
+c u-------input-R-vitesse dans la direction X (de O a E) en m/s
+c v-------input-R-vitesse Y (de S a N) en m/s
+c t-------input-R-temperature (K)
+c qx------input-R-mass mixing ratio traceurs (kg/kg) 
+c d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
+c omega---input-R-vitesse verticale en Pa/s
 c
 c d_u-----output-R-tendance physique de "u" (m/s/s)
@@ -62,10 +61,21 @@
       USE comgeomphy
       use cpdet_mod, only: cpdet, t2tpot
+      USE mod_phys_lmdz_para, only : is_parallel,jj_nb
+      USE phys_state_var_mod ! Variables sauvegardees de la physique
+      USE iophy
+      USE common_mod, only: rmcbar,xfbar,ncount,
+     &      flxesp_i,tau_drop,tau_aer,solesp,precip,
+     &      evapch4,occcld_m,occcld,satch4,satc2h6,satc2h2,rmcloud,
+     &      TauHID,TauHVD,TauGID,TauGVD,TauCID,TauCVD,NSPECV,NSPECI,
+     &      common_init
+
+      USE moyzon_mod
+      USE write_field_phy
       IMPLICIT none
 c======================================================================
 c   CLEFS CPP POUR LES IO
 c   =====================
+#define histday
 #define histmth
-#define histday
 #define histins
 c======================================================================
@@ -78,17 +88,16 @@
 #include "iniprint.h"
 #include "logic.h"
+#include "tabcontrol.h"
 #include "comorbit.h"
 #include "microtab.h"
-#include "diagmuphy.h"
-#include "tabcontrol.h"
 #include "itemps.h"
 c======================================================================
+      LOGICAL ok_journe ! sortir le fichier journalier
+      save ok_journe
+c      PARAMETER (ok_journe=.true.)
+c
       LOGICAL ok_mensuel ! sortir le fichier mensuel
       save ok_mensuel
 c      PARAMETER (ok_mensuel=.true.)
-c
-      LOGICAL ok_journe ! sortir le fichier journalier
-      save ok_journe
-c      PARAMETER (ok_journe=.true.)
 c
       LOGICAL ok_instan ! sortir le fichier instantane
@@ -121,9 +130,4 @@
       REAL qx(klon,klev,nqmax)
 
-      REAL,save,allocatable :: t_ancien(:,:)
-      REAL,save,allocatable :: u_ancien(:,:)
-      LOGICAL ancien_ok
-      SAVE ancien_ok
-
       REAL d_u_dyn(klon,klev)
       REAL d_t_dyn(klon,klev)
@@ -137,30 +141,10 @@
       REAL d_ps(klon)
 
-      REAL,save,allocatable :: swnet(:,:)
-      REAL,save,allocatable :: lwnet(:,:)
-c
 c Variables propres a la physique
 c
-      REAL,save,allocatable :: radsol(:) ! bilan radiatif au sol calcule par code radiatif
       REAL,save,allocatable :: rlev(:,:) ! altitude a chaque niveau (interface inferieure de la couche) 
       INTEGER,save :: itap        ! compteur pour la physique
-      REAL,save,allocatable :: ftsol(:)    ! temperature du sol
-      REAL,save,allocatable :: ftsoil(:,:) ! temperature dans le sol
-      REAL,save,allocatable :: falbe(:)    ! albedo 
       REAL delp(klon,klev)        ! epaisseur d'une couche
       
-CMODDEB FLOTT
-c
-c  Parametres de l'Orographie a l'Echelle Sous-Maille (OESM):
-c
-      REAL,save,allocatable :: zmea(:)   ! orographie moyenne
-      REAL,save,allocatable :: zstd(:)   ! deviation standard de l'OESM
-      REAL,save,allocatable :: zsig(:)   ! pente de l'OESM
-      REAL,save,allocatable :: zgam(:)   ! anisotropie de l'OESM
-      REAL,save,allocatable :: zthe(:)   ! orientation de l'OESM
-      REAL,save,allocatable :: zpic(:)   ! Maximum de l'OESM
-      REAL,save,allocatable :: zval(:)   ! Minimum de l'OESM
-      REAL,save,allocatable :: rugoro(:) ! longueur de rugosite de l'OESM
-
       INTEGER igwd,idx(klon),itest(klon)
 c
@@ -191,6 +175,4 @@
 
       REAL zustrph(klon),zvstrph(klon) 
-c
-      REAL,save,allocatable :: zuthe(:),zvthe(:)
 
 c Variables locales:
@@ -199,19 +181,17 @@
       REAL cdragm(klon) ! drag coefficient pour vent
 c
-cAA  Pour TRACEURS 
+cAA  Pour  TRACEURS
 cAA
       REAL,save,allocatable :: source(:,:)
       integer nmicro
       save    nmicro
+      character*8 nom
+      REAL qaer(klon,klev,nqmax)
 
       REAL ycoefh(klon,klev)    ! coef d'echange pour phytrac
       REAL yu1(klon)            ! vents dans la premiere couche U
       REAL yv1(klon)            ! vents dans la premiere couche V
-      character*8 nom
-      REAL qaer(klon,klev,nqmax)
 
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
-      REAL,save,allocatable :: dlw(:)  ! derivee infra rouge
-      REAL,save,allocatable :: fder(:) ! Derive de flux (sensible et latente) 
       REAL ve(klon) ! integr. verticale du transport meri. de l'energie
       REAL vq(klon) ! integr. verticale du transport meri. de l'eau
@@ -232,5 +212,5 @@
       EXTERNAL radlwsw   ! rayonnements solaire et infrarouge
       EXTERNAL suphec    ! initialiser certaines constantes
-c      EXTERNAL transp    ! transport total de l'eau et de l'energie
+c     EXTERNAL transp    ! transport total de l'eau et de l'energie
       EXTERNAL abort_gcm
       EXTERNAL printflag
@@ -253,14 +233,4 @@
       REAL flux_ec(klon,klev)   ! flux de chaleur Ec
 c
-c Le rayonnement n'est pas calcule tous les pas, il faut donc
-c                      sauvegarder les sorties du rayonnement
-      REAL,save,allocatable :: heat(:,:)    ! chauffage solaire
-      REAL,save,allocatable :: cool(:,:)    ! refroidissement infrarouge
-      REAL,save,allocatable :: dtrad(:,:)   ! K s-1 
-      REAL,save,allocatable :: topsw(:), toplw(:)
-      REAL,save,allocatable :: solsw(:), sollw(:)
-      REAL,save,allocatable :: sollwdown(:) ! downward LW flux at surface
-      REAL tmpout(klon,klev)  ! K s-1 
-
       REAL    dtimerad
       INTEGER itaprad
@@ -268,5 +238,4 @@
       REAL zdtime
 c
-
 c CHIMIE
 
@@ -278,4 +247,5 @@
 
       REAL dist, rmu0(klon), fract(klon), pdecli
+      REAL rmu0bar(klon), fractbar(klon)
       REAL zday
       REAL zls,zlsdeg,zlsm1
@@ -332,15 +302,9 @@
 c
       REAL tr_seri(klon,klev,nqmax)
+      REAL d_tr(klon,klev,nqmax)
 c
 c pour ioipsl
-      INTEGER ndex2d(iim*jjmp1),ndex3d(iim*jjmp1*klev)
-      REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
-      REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
-      REAL zx_tmp_2d(iim,jjmp1),zx_tmp_3d(iim,jjmp1,klev)
-      REAL zx_lon(iim,jjmp1), zx_lat(iim,jjmp1)
-
       INTEGER nid_day, nid_mth, nid_ins
       SAVE nid_day, nid_mth, nid_ins
-c
       INTEGER nhori, nvert, idayref
       REAL zsto, zout, zsto1, zsto2, zero
@@ -348,5 +312,7 @@
       real zjulian
       save zjulian
-
+      REAL tmpout(klon,klev)  ! pour sorties
+
+      CHARACTER*1  str1
       CHARACTER*2  str2
       character*20 modname
@@ -383,6 +349,4 @@
       REAL mangtot            ! moment cinetique total
 
-      CHARACTER*2 str1
-
 c Temporaire avant de trouver mieux :
 c Recuperation des TAU du TR
@@ -390,24 +354,4 @@
       REAL t_tcld(klon,klev),t_kcld(klon,klev)
       REAL t_kcvd(klon,klev)
-c  ASTUCE POUR EVITER klon... EN ATTENDANT MIEUX
-      INTEGER   ngrid
-      PARAMETER (ngrid=(jjm-1)*iim+2)  ! = klon
-      INTEGER NSPECV,NSPECI,NLAYER
-      PARAMETER (NSPECV=24,NSPECI=46,NLAYER=llm)
-      REAL TAUHID(ngrid,NLAYER,NSPECI)
-     &               ,TAUCID(ngrid,NLAYER,NSPECI)
-     &               ,TAUGID(ngrid,NLAYER,NSPECI)
-     &               ,TAUHVD(ngrid,NLAYER,NSPECV)
-     &               ,TAUCVD(ngrid,NLAYER,NSPECV)
-     &               ,TAUGVD(ngrid,NLAYER,NSPECV)
-
-      COMMON /TAUD/   TAUHID,TAUCID,TAUGID,TAUHVD,TAUCVD,TAUGVD
-      COMMON /PLANT/ CSUBP,F0PI
-      REAL CSUBP,F0PI
-
-* common relatifs au nuages
-      real rmcbar(ngrid,NLAYER),xfbar(ngrid,NLAYER,4) 
-      integer ncount(ngrid,NLAYER)
-      COMMON/rnuabar/ncount,rmcbar,xfbar
 
        REAL ch4(klon,jjm+1),dch4(jjm+1)
@@ -427,5 +371,5 @@
 c======================================================================
 c INITIALISATIONS
-c======================================================================
+c================
 
       modname = 'physiq'
@@ -434,4 +378,9 @@
       bilansmc = 0
       ballons  = 0
+! NE FONCTIONNENT PAS ENCORE EN PARALLELE !!!
+      if (is_parallel) then
+        bilansmc = 0
+        ballons  = 0
+      endif
 
       IF (if_ebil.ge.1) THEN
@@ -449,14 +398,5 @@
 c========================
       IF (debut) THEN
-         allocate(t_ancien(klon,klev),u_ancien(klon,klev))
-         allocate(swnet(klon,klevp1),lwnet(klon,klevp1))
-         allocate(radsol(klon),ftsol(klon),falbe(klon))
-         allocate(rlev(klon,klevp1),ftsoil(klon,nsoilmx))
-         allocate(zmea(klon),zstd(klon),zsig(klon),zgam(klon))
-         allocate(zthe(klon),zpic(klon),zval(klon),rugoro(klon))
-         allocate(zuthe(klon),zvthe(klon),dlw(klon),fder(klon))
-         allocate(heat(klon,klev),cool(klon,klev))
-         allocate(dtrad(klon,klev),topsw(klon),toplw(klon))
-         allocate(solsw(klon),sollw(klon),sollwdown(klon))
+         allocate(rlev(klon,klevp1))
          allocate(source(klon,nqmax))
          allocate(reservoir(klon))
@@ -468,26 +408,28 @@
 c appel a la lecture du physiq.def 
 c
-         call conf_phys(ok_mensuel,ok_journe,ok_instan,if_ebil)
-
+         call conf_phys(ok_journe, ok_mensuel,
+     .                  ok_instan,
+     .                  if_ebil)
+
+         call phys_state_var_init
+         call common_init
 c
 c Initialiser les compteurs:
 c
-         itap        = 0
-         itaprad     = 0
+         itap    = 0
+         itaprad = 0
          itapchim    = 0
+
+c init rnuabar
          ncount(:,:) = 0
-
+         rmcbar  = 0.
+         xfbar   = 0.
+         
 c         
 c Lecture startphy.nc :
 c
-c REMETTRE TOUS LES PARAMETRES POUR OROGW...  A FAIRE POUR TITAN
-         CALL phyetat0 ("startphy.nc",
-     .       rlatd,rlond,ftsol,ftsoil,
-     .       falbe, solsw, sollw,
-     .       dlw,radsol,reservoir,
-c     .      zmea,zstd,zsig,zgam,zthe,zpic,zval,
-     .       t_ancien, ancien_ok)
-
-c dtime est defini dans tabcontrol.h et lu dans startphy 
+         CALL phyetat0 ("startphy.nc")
+
+c dtime est defini dans tabcontrol.h et lu dans startphy
 c pdtphys est calcule a partir des nouvelles conditions:
 c Reinitialisation du pas de temps physique quand changement
@@ -508,13 +450,12 @@
          chimpas =   radpas*nbapp_rad/nbapp_chim
 
-         CALL printflag( ok_mensuel,ok_journe, ok_instan )
-
+         CALL printflag( ok_mensuel,ok_journe,ok_instan )
 c
 c Initialiser les pas de temps:
 c
-      dtimerad = dtime*FLOAT(radpas)  ! pas de temps du rayonnement (s)
+      dtimerad = dtime*REAL(radpas)  ! pas de temps du rayonnement (s)
 c      PRINT*,'dtimerad,dtime,radpas',dtimerad,dtime,radpas
             
-      dtimechim = dtime*FLOAT(chimpas)  ! pas de temps de la chimie (s)
+      dtimechim = dtime*REAL(chimpas)  ! pas de temps de la chimie (s)
 c      PRINT*,'dtimechim,dtime,chimpas',dtimechim,dtime,chimpas
 
@@ -526,18 +467,18 @@
 c---------
 c FLOTT
-c       IF (ok_orodr) THEN
-c         DO i=1,klon
-c         rugoro(i) = MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
-c         ENDDO
-c         CALL SUGWD(klon,klev,paprs,pplay)
-c         DO i=1,klon
-c         zuthe(i)=0.
-c         zvthe(i)=0.
-c         if(zstd(i).gt.10.)then
-c           zuthe(i)=(1.-zgam(i))*cos(zthe(i))
-c           zvthe(i)=(1.-zgam(i))*sin(zthe(i))
-c         endif
-c         ENDDO
-c       ENDIF
+       IF (ok_orodr) THEN
+         DO i=1,klon
+         rugoro(i) = MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
+         ENDDO
+         CALL SUGWD(klon,klev,paprs,pplay)
+         DO i=1,klon
+         zuthe(i)=0.
+         zvthe(i)=0.
+         if(zstd(i).gt.10.)then
+           zuthe(i)=(1.-zgam(i))*cos(zthe(i))
+           zvthe(i)=(1.-zgam(i))*sin(zthe(i))
+         endif
+         ENDDO
+       ENDIF
 
       if (bilansmc.eq.1) then
@@ -566,5 +507,5 @@
 C TRACEURS
 C source dans couche limite
-          source = 0.0 ! pas de source, pour l'instant
+         source = 0.0 ! pas de source, pour l'instant
 C
 c Si microphysique offline, pas besoin d'avoir de traceurs microphysiques
@@ -586,7 +527,7 @@
       print*,"nmicro=",nmicro
 
-c
+c --------------
 c Verifications:
-c
+c --------------
          IF ((nmicro.eq.0).and.(microfi.eq.1)) THEN
            abort_message="MICROPHYSIQUE ONLINE, MAIS NMICRO=0..."
@@ -611,6 +552,21 @@
             call abort_gcm(modname,abort_message,1)
          ENDIF
-c
-         IF (dtime*FLOAT(radpas).GT.(RDAY*0.25).AND.cycle_diurne)
+
+         IF (((moyzon_mu).and.(microfi.ne.1)).or.
+     .       ((.not.moyzon_mu).and.(microfi.eq.1))) THEN
+           abort_message="Microphysic 2D and moyzon_mu not compatible"
+           write(lunout,*) "moyzon_mu=",moyzon_mu
+           write(lunout,*) "microfi=",microfi
+           call abort_gcm(modname,abort_message,1) 
+         ENDIF
+         IF (((moyzon_ch).and.(.not.chimi)).or.
+     .       ((.not.moyzon_ch).and.(chimi))) THEN
+           abort_message="Chemistry and moyzon_ch not compatible"
+           write(lunout,*) "moyzon_ch=",moyzon_ch
+           write(lunout,*) "chimi=",chimi
+           call abort_gcm(modname,abort_message,1) 
+         ENDIF
+
+         IF (dtime*REAL(radpas).GT.(RDAY*0.25).AND.cycle_diurne)
      $    THEN 
            WRITE(lunout,*)'Nbre d appels au rayonnement insuffisant'
@@ -625,5 +581,5 @@
          ecrit_mth = NINT(RDAY/dtime) *nday  ! tous les nday jours
          IF (ok_mensuel) THEN
-         WRITE(lunout,*)'La frequence de sortie mensuelle est de ',
+         WRITE(lunout,*)'La frequence de sortie mensuelle est de ', 
      .                   ecrit_mth
          ENDIF
@@ -646,12 +602,12 @@
 #ifdef CPP_IOIPSL
 
+#ifdef histday
+#include "ini_histday.h"
+#endif
+
 #ifdef histmth
 #include "ini_histmth.h"
 #endif
 
-#ifdef histday
-#include "ini_histday.h"
-#endif
-
 #ifdef histins
 #include "ini_histins.h"
@@ -670,7 +626,4 @@
       ENDDO
 
-      rmcbar  = 0.
-      xfbar   = 0.
-         
       ENDIF ! debut
 c====================================================================
@@ -719,5 +672,5 @@
 C
       DO i = 1, klon
-          ztsol(i) = ftsol(i) 
+          ztsol(i) = ftsol(i)
       ENDDO
 C
@@ -777,4 +730,7 @@
       ENDDO
 
+c     call WriteField_phy('physiq_pphi',pphi,klev)
+c     call WriteField_phy('physiq_pphis',pphis,1)
+
 c   calcul du geopotentiel aux niveaux intercouches
 c   ponderation des altitudes au niveau des couches en dp/p
@@ -796,5 +752,5 @@
          DO i=1,klon
             z1=(pplay(i,l-1)+paprs(i,l))/(pplay(i,l-1)-paprs(i,l))
-            z2=(paprs(i,l)+pplay(i,l))/(paprs(i,l)-pplay(i,l))
+            z2=(paprs(i,l)  +pplay(i,l))/(paprs(i,l)  -pplay(i,l))
             zzlev(i,l)=(z1*zzlay(i,l-1)+z2*zzlay(i,l))/(z1+z2)
          ENDDO
@@ -804,4 +760,49 @@
       ENDDO
 
+! zonal averages needed
+      if (moyzon_ch.or.moyzon_mu) then
+
+c      zzlaybar(1,:)=(zphibar(1,:)+zphisbar(1))/RG
+c SI ON TIENT COMPTE DE LA VARIATION DE G AVEC L'ALTITUDE:
+       zzlaybar(1,:)=RG*RA*RA/(RG*RA-(zphibar(1,:)+zphisbar(1)))-RA
+       zzlevbar(1,1)=zphisbar(1)/RG
+       DO l=2,klev
+            z1=(zplaybar(1,l-1)+zplevbar(1,l))/
+     .            (zplevbar(1,l-1)-zplevbar(1,l))
+            z2=(zplevbar(1,l)  +zplaybar(1,l))/
+     .            (zplevbar(1,l)  -zplaybar(1,l))
+            zzlevbar(1,l)=(z1*zzlaybar(1,l-1)+z2*zzlaybar(1,l))/(z1+z2)
+       ENDDO
+       zzlevbar(1,klev+1)=zzlaybar(1,klev)+
+     .            (zzlaybar(1,klev)-zzlevbar(1,klev))
+
+       DO i=2,klon
+        if (rlatd(i).ne.rlatd(i-1)) then
+         DO l=1,klev
+c         zzlaybar(i,l)=(zphibar(i,l)+zphisbar(i))/RG
+c SI ON TIENT COMPTE DE LA VARIATION DE G AVEC L'ALTITUDE:
+          zzlaybar(i,l)=RG*RA*RA/(RG*RA-(zphibar(i,l)+zphisbar(i)))-RA
+         ENDDO
+         zzlevbar(i,1)=zphisbar(i)/RG
+         DO l=2,klev
+            z1=(zplaybar(i,l-1)+zplevbar(i,l))/
+     .            (zplevbar(i,l-1)-zplevbar(i,l))
+            z2=(zplevbar(i,l)  +zplaybar(i,l))/
+     .            (zplevbar(i,l)  -zplaybar(i,l))
+            zzlevbar(i,l)=(z1*zzlaybar(i,l-1)+z2*zzlaybar(i,l))/(z1+z2)
+         ENDDO
+         zzlevbar(i,klev+1)=zzlaybar(i,klev)+
+     .              (zzlaybar(i,klev)-zzlevbar(i,klev))
+        else
+         zzlaybar(i,:)=zzlaybar(i-1,:)
+         zzlevbar(i,:)=zzlevbar(i-1,:)
+        endif
+       ENDDO
+
+      endif  ! moyzon
+
+c     call WriteField_phy('physiq_zphi',zphi,klev)
+c     call WriteField_phy('physiq_zzlay',zzlay,klev)
+c     call WriteField_phy('physiq_zzlev',zzlev,klev+1)
 c- - - - - - - - - - - - - - - -
 c DIAGNOSTIQUE GRILLE VERTICALE
@@ -838,11 +839,7 @@
       ENDDO
 
-
-
-
-c====================================================================
-c ORBITE ET ECLAIREMENT
-c====================================================================
-
+c====================================================================
+c Orbite et eclairement
+c====================================================================
 
 c Pour TITAN:
@@ -856,13 +853,15 @@
 
 c dans zenang, Ls en degres ; dans mucorr, Ls en radians
+      call mucorr(klon,zls,rlatd,rmu0bar,fractbar)
       IF (cycle_diurne) THEN
-        zdtime=dtime*FLOAT(radpas) ! pas de temps du rayonnement (s)
+        zdtime=dtime*REAL(radpas) ! pas de temps du rayonnement (s)
         CALL zenang(zlsdeg,gmtime,zdtime,rlatd,rlond,rmu0,fract)
       ELSE
-        call mucorr(klon,zls,rlatd,rmu0,fract)
+        rmu0  = rmu0bar
+        fract = fractbar
       ENDIF
-
-c====================================================================
-c COUCHE LIMITE 
+      
+c====================================================================
+c Appeler la diffusion verticale (programme de couche limite)
 c====================================================================
 
@@ -901,7 +900,6 @@
 c     print*,"sollw avant clmain=",sollw(klon/2)
 
-c  CLMAIN
-
 ! ADAPTATION GCM POUR CP(T)
+
       CALL clmain(dtime,itap,
      e            t_seri,u_seri,v_seri,
@@ -911,5 +909,5 @@
      $            paprs,pplay,ppk,radsol,falbe,
      e            solsw, sollw, sollwdown, fder,
-     e            rlond, rlatd, cuphy, cvphy, 
+     e            rlond, rlatd, cuphy, cvphy,   
      e            debut, lafin,
      s            d_t_vdf,d_u_vdf,d_v_vdf,d_ts,
@@ -940,9 +938,7 @@
       ENDDO
 
-c        print*,"d_t_vdf1=",d_t_vdf(1,:)*dtime
-c        print*,"d_t_vdf2=",d_t_vdf(klon/2,:)*dtime
-c        print*,"d_t_vdf3=",d_t_vdf(klon,:)*dtime
-c        print*,"d_u_vdf=",d_u_vdf(klon/2,:)*dtime
-c        print*,"d_v_vdf=",d_v_vdf(klon/2,:)*dtime
+c     call WriteField_phy('physiq_dtvdf',d_t_vdf,klev)
+c     call WriteField_phy('physiq_duvdf',d_u_vdf,klev)
+c     call WriteField_phy('physiq_dvvdf',d_v_vdf,klev)
 
 C TRACEURS
@@ -950,13 +946,12 @@
       d_tr_vdf = 0.
       if (iflag_trac.eq.1) then
-      DO iq=1, nqmax
-          CALL cltrac(dtime,ycoefh,t_seri,
-     s               tr_seri(1,1,iq), source,
-     e               paprs, pplay, delp,
+         DO iq=1, nqmax
+             CALL cltrac(dtime,ycoefh,t_seri,
+     s               tr_seri(1,1,iq),source,
+     e               paprs, pplay,delp,
      s               d_tr_vdf(1,1,iq))
-
-          tr_seri(:,:,iq) = tr_seri(:,:,iq) + d_tr_vdf(:,:,iq)
-          d_tr_vdf(:,:,iq)= d_tr_vdf(:,:,iq)/dtime          ! /s
-      ENDDO
+             tr_seri(:,:,iq) = tr_seri(:,:,iq) + d_tr_vdf(:,:,iq)
+             d_tr_vdf(:,:,iq)= d_tr_vdf(:,:,iq)/dtime          ! /s
+         ENDDO
       endif
 
@@ -976,10 +971,10 @@
 c Incrementer la temperature du sol
 c
-c     print*,'Tsol avant clmain:',ftsol(klon/2)
+c     print*,'Tsol avant clmain:',ftsol(1)
       DO i = 1, klon
          ftsol(i) = ftsol(i) + d_ts(i)
       ENDDO
 c     print*,'DTsol apres clmain:',d_ts(klon/2)
-c     print*,'Tsol apres clmain:',ftsol(klon/2)
+c     print*,'Tsol apres clmain:',ftsol(1)
 
 c Calculer la derive du flux infrarouge
@@ -1040,13 +1035,11 @@
          d_v_ajs(:,:)= d_v_ajs(:,:)/dtime          ! (m/s)/s
       if (iflag_trac.eq.1) then
-         tr_seri(:,:,:) = tr_seri(:,:,:) + d_tr_ajs(:,:,:)
-         d_tr_ajs(:,:,:)= d_tr_ajs(:,:,:)/dtime          ! /s
+           tr_seri(:,:,:) = tr_seri(:,:,:) + d_tr_ajs(:,:,:)
+           d_tr_ajs(:,:,:)= d_tr_ajs(:,:,:)/dtime  ! /s
       endif
-      
-c        print*,"d_t_ajs1=",d_t_ajs(1,:)*dtime
-c        print*,"d_t_ajs2=",d_t_ajs(klon/2,:)*dtime
-c        print*,"d_t_ajs3=",d_t_ajs(klon,:)*dtime
-c        print*,"d_u_ajs=",d_u_ajs(klon/2,:)*dtime
-c        print*,"d_v_ajs=",d_v_ajs(klon/2,:)*dtime
+
+c     call WriteField_phy('physiq_dtajs',d_t_ajs,klev)
+c     call WriteField_phy('physiq_duajs',d_u_ajs,klev)
+c     call WriteField_phy('physiq_dvajs',d_v_ajs,klev)
 
       endif
@@ -1090,11 +1083,32 @@
 
       if (iflag_trac.eq.1) then
+c        call WriteField_phy('physiq_qaer01',
+c    .                          qaer(:,:,1),klev)
+c        call WriteField_phy('physiq_qaer10',
+c    .                          qaer(:,:,10),klev)
+c        call WriteField_phy('physiq_tr_seri01',
+c    .                          tr_seri(:,:,1),klev)
+c        call WriteField_phy('physiq_tr_seri10',
+c    .                          tr_seri(:,:,10),klev)
+
 c         call begintime(tt0)
+c in phytrac call, mu0 and fract are only used in brume
+c so we need to pass either rmu0 ou rmu0bar depending on
+c moyzon_mu
+       if (moyzon_mu) then
          call phytrac (debut,lafin,
-     .                   nqmax,nmicro,dtime,appel_chim,dtimechim,
-     .                   paprs,pplay,delp,t,rmu0,fract,pdecli,zls,
-     .                   yu1,yv1,zzlev,zzlay,ftsol,
-     .                   tr_seri,qaer,d_tr_mph,d_tr_kim,
-     .                   fclat,reservoir)
+     .                 nqmax,nmicro,dtime,appel_chim,dtimechim,
+     .                 paprs,pplay,delp,t,rmu0bar,fractbar,pdecli,zls,
+     .                 yu1,yv1,zzlev,zzlay,ftsol,
+     .                 tr_seri,qaer,d_tr_mph,d_tr_kim,
+     .                 fclat,reservoir)
+       else
+         call phytrac (debut,lafin,
+     .                 nqmax,nmicro,dtime,appel_chim,dtimechim,
+     .                 paprs,pplay,delp,t,rmu0,fract,pdecli,zls,
+     .                 yu1,yv1,zzlev,zzlay,ftsol,
+     .                 tr_seri,qaer,d_tr_mph,d_tr_kim,
+     .                 fclat,reservoir)
+       endif
 
 c         call endtime(tt0,tt1)
@@ -1112,4 +1126,8 @@
          tr_seri(:,:,1:nmicro) = tr_seri(:,:,1:nmicro)
      .                        + d_tr_mph(:,:,1:nmicro)*dtime
+c        call WriteField_phy('physiq_d_tr_mph01',
+c    .                          d_tr_mph(:,:,1),klev)
+c        call WriteField_phy('physiq_d_tr_mph10',
+c    .                          d_tr_mph(:,:,10),klev)
 	endif
 c       PAS ELEGANT mais je n'ai pas trouve d'autres solutions :
@@ -1195,6 +1213,6 @@
         DO i=1,klon
           DO j=1,klev
-            rmcbar(i,j)=rmcbar(i,j)/MAX(FLOAT(ncount(i,j)),1.)
-            xfbar(i,j,:)=xfbar(i,j,:)/MAX(FLOAT(ncount(i,j)),1.)
+            rmcbar(i,j)=rmcbar(i,j)/MAX(REAL(ncount(i,j)),1.)
+            xfbar(i,j,:)=xfbar(i,j,:)/MAX(REAL(ncount(i,j)),1.)
           ENDDO 
         ENDDO
@@ -1203,11 +1221,9 @@
 c      call begintime(tt0)
       CALL radlwsw
-     e            (dist, rmu0, fract, falbe, zzlev,
+     e            (dist, rmu0, fract, zzlev,
      e             paprs, pplay,ftsol, t_seri, nqmax, nmicro,
-     c             tr_seri, qaer,
-     s             heat,cool,radsol,
-     s             topsw,toplw,solsw,sollw,
-     s             sollwdown,
-     s             lwnet, swnet)
+     c             tr_seri, qaer)
+c     print*,"apres radlwsw"
+
 c      call endtime(tt0,tt1)
 c      ttrad=ttrad+tt1
@@ -1221,7 +1237,4 @@
       ENDIF
 
-c     print*,"radsol apres radlwsw=",radsol(klon/2)
-c     print*,"solsw apres radlwsw=",solsw(klon/2)
-c     print*,"sollw apres radlwsw=",sollw(klon/2)
       itaprad = 0
       DO k = 1, klev
@@ -1230,10 +1243,8 @@
        ENDDO
       ENDDO
-c       print*,"heat (K/s) =",heat(klon/2,:)
-c       print*,"cool (K/s) =",cool(klon/2,:)
-c       print*,"dtrad1 (K/s) =",dtrad(1,:)
-c       print*,"dtrad2 (K/s) =",dtrad(klon/2,:)
-c       print*,"dtrad3 (K/s) =",dtrad(klon,:)
-	    
+
+c     call WriteField_phy('physiq_heat',heat,klev)
+c     call WriteField_phy('physiq_cool',cool,klev)
+
       ENDIF
       itaprad = itaprad + 1
